using System;
using System.Collections;
using System.Drawing;
using PaintDotNet;
using PaintDotNet.Effects;
using System.Runtime.InteropServices;
using System.Reflection;

namespace KlumpNoiz
{
    public class PluginSupportInfo : IPluginSupportInfo
    {
        public string Author
        {
            get
            {
                return ((AssemblyCompanyAttribute)base.GetType().Assembly.GetCustomAttributes(typeof(AssemblyCompanyAttribute), false)[0]).Company;
            }
        }
        public string Copyright
        {
            get
            {
                return ((AssemblyCopyrightAttribute)base.GetType().Assembly.GetCustomAttributes(typeof(AssemblyCopyrightAttribute), false)[0]).Copyright;
            }
        }

        public string DisplayName
        {
            get
            {
                return ((AssemblyProductAttribute)base.GetType().Assembly.GetCustomAttributes(typeof(AssemblyProductAttribute), false)[0]).Product;
            }
        }

        public Version Version
        {
            get
            {
                return base.GetType().Assembly.GetName().Version;
            }
        }

        public Uri WebsiteUri
        {
            get
            {
                return new Uri("http://www.technorobbo.com");
            }
        }
    }
    [PluginSupportInfo(typeof(PluginSupportInfo), DisplayName = "TR's KlumpNoiz")]
    public class EffectPlugin
        : PaintDotNet.Effects.Effect
    {
        public static string StaticName
        {
            get
            {
                return "TR's KlumpNoiz";
            }
        }

        public static Bitmap StaticImage { get { return Properties.Resources.Icon; } }

        public static string StaticSubMenuName
        {
            get
            {
                return SubmenuNames.Noise; 
            }
        }

        public EffectPlugin()
            : base(EffectPlugin.StaticName, EffectPlugin.StaticImage, EffectPlugin.StaticSubMenuName, EffectFlags.Configurable)
        {

        }

        public override EffectConfigDialog CreateConfigDialog()
        {
            return new EffectPluginConfigDialog();
        }

        bool dosave = false; //  Save Change
        protected override void OnSetRenderInfo(EffectConfigToken parameters, RenderArgs dstArgs, RenderArgs srcArgs)
        {
            EffectPluginConfigToken token = (EffectPluginConfigToken)parameters;
            PdnRegion selectionRegion = EnvironmentParameters.GetSelection(srcArgs.Bounds);
            Rectangle rect = srcArgs.Bounds;

            this.dosave = token.Save;

            base.OnSetRenderInfo(parameters, dstArgs, srcArgs);

            if (dosave)
            {
                Bitmap b = new Bitmap(System.IO.Path.GetTempPath() + @"TRsKN.bmp");
                Graphics g = new RenderArgs(dstArgs.Surface).Graphics;
                g.DrawImage(b, 0, 0);
                g.Dispose();
                b.Dispose();
            }

        }
        public override void Render(EffectConfigToken parameters, RenderArgs dstArgs, RenderArgs srcArgs, Rectangle[] rois, int startIndex, int length)
        {

        }
        protected override void OnDispose(bool disposing)
        {
        }
    }
}