using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Text.RegularExpressions;
using System.Windows.Forms;
using PaintDotNet.Effects;
using PaintDotNet;
using System.Drawing.Drawing2D;
using System.Reflection;

namespace KlumpNoiz
{
    public class EffectPluginConfigDialog : PaintDotNet.Effects.EffectConfigDialog
    {
        private bool saver = false;
        Random rnd = new Random((int)Guid.NewGuid().GetHashCode());
        Rectangle mybounds;
        Rectangle panelbounds;
        Bitmap bmp;
        bool RenderComplete = false;
        int[,] grid = { { 1, 1 }, { -1, -1 }, { 1, -1 }, { -1, 1 }, { 0, 1 }, { 1, 0 }, { -1, 0 }, { 0, -1 } };
        int[] biasgrid = { -9, 0, 1, 2, 3, 4, 5, 6, 7, 9, 10, 11, 12, 13, 14, 15, 18, 19, 20, 21, 22, 23, 27, 
                             28, 29, 30, 31, 36, 37, 38, 39, 45, 46, 47, 54, 55, 63 };
        int[] hue = { 240, 0 };
        int[] sat = { 100, 0 };
        int[] val = { 100, 100 };
        int[] alph = { 255, 255 };
        Color[] colorval = { Color.Blue, Color.White };
        bool[] colorpicked = new bool[2];

        bool GlobalCancel = false;

        private Button buttonOK;
        private Label bias_lab;
        private Label choices_lab;
        private ProgressBar progressBar1;
        private Button button2;
        private Button button1;
        private HScrollBar bias;
        private HScrollBar choices;
        private HScrollBar reps;
        private HScrollBar sn;
        private Panel panel1;
        //private IContainer components;
        private Label reps_lab;
        private Label sn_lab;
        private Label label2;
        private Controlz.ColorWheelTR cw1;
        private Controlz.ColorWheelTR cw2;
        private Button buttonCancel;


        public EffectPluginConfigDialog()
        {
            InitializeComponent();
        }

        protected override void InitialInitToken()
        {
            theEffectToken = new EffectPluginConfigToken(false,1,120,2,0,Color.Red,Color.Blue);
        }

        protected override void InitTokenFromDialog()
        {
            ((EffectPluginConfigToken)EffectToken).Save = saver;
            ((EffectPluginConfigToken)EffectToken)._Sn = sn.Value;
            ((EffectPluginConfigToken)EffectToken)._Reps = reps.Value;
            ((EffectPluginConfigToken)EffectToken)._Bias = bias.Value;
            ((EffectPluginConfigToken)EffectToken)._Choices=choices.Value;
            ((EffectPluginConfigToken)EffectToken)._Color1 = colorval[0];
            ((EffectPluginConfigToken)EffectToken)._Color2 = colorval[1];

        }

        protected override void InitDialogFromToken(EffectConfigToken effectToken)
        {
            EffectPluginConfigToken token = (EffectPluginConfigToken)effectToken;
            saver = false;
            sn.Value = token._Sn;
            reps.Value = token._Reps;
            choices.Value = token._Choices;
            bias.Value = token._Bias;
            colorval[0] = token._Color1;
            cw1.colorval = token._Color1;
            colorval[1] = token._Color2;
            cw2.colorval = token._Color2;
        }



        private void InitializeComponent()
        {
            this.buttonCancel = new System.Windows.Forms.Button();
            this.buttonOK = new System.Windows.Forms.Button();
            this.bias_lab = new System.Windows.Forms.Label();
            this.choices_lab = new System.Windows.Forms.Label();
            this.progressBar1 = new System.Windows.Forms.ProgressBar();
            this.button2 = new System.Windows.Forms.Button();
            this.button1 = new System.Windows.Forms.Button();
            this.bias = new System.Windows.Forms.HScrollBar();
            this.choices = new System.Windows.Forms.HScrollBar();
            this.reps = new System.Windows.Forms.HScrollBar();
            this.sn = new System.Windows.Forms.HScrollBar();
            this.panel1 = new System.Windows.Forms.Panel();
            this.reps_lab = new System.Windows.Forms.Label();
            this.sn_lab = new System.Windows.Forms.Label();
            this.label2 = new System.Windows.Forms.Label();
            this.cw2 = new Controlz.ColorWheelTR();
            this.cw1 = new Controlz.ColorWheelTR();
            this.SuspendLayout();
            // 
            // buttonCancel
            // 
            this.buttonCancel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
            this.buttonCancel.Location = new System.Drawing.Point(533, 385);
            this.buttonCancel.Name = "buttonCancel";
            this.buttonCancel.Size = new System.Drawing.Size(75, 23);
            this.buttonCancel.TabIndex = 1;
            this.buttonCancel.Text = "Cancel";
            this.buttonCancel.UseVisualStyleBackColor = true;
            this.buttonCancel.Click += new System.EventHandler(this.buttonCancel_Click);
            // 
            // buttonOK
            // 
            this.buttonOK.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
            this.buttonOK.Enabled = false;
            this.buttonOK.Location = new System.Drawing.Point(452, 387);
            this.buttonOK.Name = "buttonOK";
            this.buttonOK.Size = new System.Drawing.Size(75, 23);
            this.buttonOK.TabIndex = 2;
            this.buttonOK.Text = "OK";
            this.buttonOK.UseVisualStyleBackColor = true;
            this.buttonOK.Click += new System.EventHandler(this.buttonOK_Click);
            // 
            // bias_lab
            // 
            this.bias_lab.AutoSize = true;
            this.bias_lab.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.bias_lab.Location = new System.Drawing.Point(346, 341);
            this.bias_lab.Name = "bias_lab";
            this.bias_lab.Size = new System.Drawing.Size(39, 13);
            this.bias_lab.TabIndex = 18;
            this.bias_lab.Tag = "Bias";
            this.bias_lab.Text = "Bias -0";
            // 
            // choices_lab
            // 
            this.choices_lab.AutoSize = true;
            this.choices_lab.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.choices_lab.Location = new System.Drawing.Point(346, 294);
            this.choices_lab.Name = "choices_lab";
            this.choices_lab.Size = new System.Drawing.Size(50, 13);
            this.choices_lab.TabIndex = 19;
            this.choices_lab.Tag = "Scatter";
            this.choices_lab.Text = "Scatter 2";
            // 
            // progressBar1
            // 
            this.progressBar1.Location = new System.Drawing.Point(10, 270);
            this.progressBar1.Name = "progressBar1";
            this.progressBar1.Size = new System.Drawing.Size(332, 16);
            this.progressBar1.TabIndex = 15;
            // 
            // button2
            // 
            this.button2.Location = new System.Drawing.Point(174, 386);
            this.button2.Name = "button2";
            this.button2.Size = new System.Drawing.Size(74, 24);
            this.button2.TabIndex = 14;
            this.button2.Text = "Stop";
            this.button2.UseVisualStyleBackColor = true;
            this.button2.Click += new System.EventHandler(this.button2_Click);
            // 
            // button1
            // 
            this.button1.Location = new System.Drawing.Point(94, 386);
            this.button1.Name = "button1";
            this.button1.Size = new System.Drawing.Size(74, 24);
            this.button1.TabIndex = 13;
            this.button1.Text = "Render Settings";
            this.button1.UseVisualStyleBackColor = true;
            this.button1.Click += new System.EventHandler(this.button1_Click);
            // 
            // bias
            // 
            this.bias.LargeChange = 1;
            this.bias.Location = new System.Drawing.Point(349, 354);
            this.bias.Maximum = 36;
            this.bias.Name = "bias";
            this.bias.Size = new System.Drawing.Size(298, 22);
            this.bias.TabIndex = 10;
            this.bias.ValueChanged += new System.EventHandler(this.generic_ValueChanged);
            // 
            // choices
            // 
            this.choices.LargeChange = 1;
            this.choices.Location = new System.Drawing.Point(349, 307);
            this.choices.Maximum = 50;
            this.choices.Minimum = 2;
            this.choices.Name = "choices";
            this.choices.Size = new System.Drawing.Size(298, 22);
            this.choices.TabIndex = 11;
            this.choices.Value = 2;
            this.choices.ValueChanged += new System.EventHandler(this.generic_ValueChanged);
            // 
            // reps
            // 
            this.reps.LargeChange = 1;
            this.reps.Location = new System.Drawing.Point(12, 351);
            this.reps.Maximum = 512;
            this.reps.Minimum = 10;
            this.reps.Name = "reps";
            this.reps.Size = new System.Drawing.Size(289, 22);
            this.reps.TabIndex = 12;
            this.reps.Value = 20;
            this.reps.ValueChanged += new System.EventHandler(this.generic_ValueChanged);
            // 
            // sn
            // 
            this.sn.LargeChange = 1;
            this.sn.Location = new System.Drawing.Point(12, 307);
            this.sn.Maximum = 5;
            this.sn.Minimum = 1;
            this.sn.Name = "sn";
            this.sn.Size = new System.Drawing.Size(289, 22);
            this.sn.TabIndex = 9;
            this.sn.Value = 1;
            this.sn.ValueChanged += new System.EventHandler(this.generic_ValueChanged);
            // 
            // panel1
            // 
            this.panel1.BackColor = System.Drawing.Color.White;
            this.panel1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.panel1.Location = new System.Drawing.Point(12, 25);
            this.panel1.Name = "panel1";
            this.panel1.Size = new System.Drawing.Size(330, 239);
            this.panel1.TabIndex = 8;
            this.panel1.Paint += new System.Windows.Forms.PaintEventHandler(this.panel1_Paint);
            // 
            // reps_lab
            // 
            this.reps_lab.AutoSize = true;
            this.reps_lab.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.reps_lab.Location = new System.Drawing.Point(5, 338);
            this.reps_lab.Name = "reps_lab";
            this.reps_lab.Size = new System.Drawing.Size(54, 13);
            this.reps_lab.TabIndex = 21;
            this.reps_lab.Tag = "Sprawl";
            this.reps_lab.Text = "Sprawl 10";
            // 
            // sn_lab
            // 
            this.sn_lab.AutoSize = true;
            this.sn_lab.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.sn_lab.Location = new System.Drawing.Point(7, 294);
            this.sn_lab.Name = "sn_lab";
            this.sn_lab.Size = new System.Drawing.Size(68, 13);
            this.sn_lab.TabIndex = 20;
            this.sn_lab.Tag = "Distribution";
            this.sn_lab.Text = "Distribution 1";
            // 
            // label2
            // 
            this.label2.AutoSize = true;
            this.label2.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, ((System.Drawing.FontStyle)((System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Italic))), System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label2.Location = new System.Drawing.Point(7, 9);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(52, 13);
            this.label2.TabIndex = 22;
            this.label2.Text = "Preview";
            // 
            // cw2
            // 
            this.cw2.colorval = System.Drawing.Color.Blue;
            this.cw2.Location = new System.Drawing.Point(349, 169);
            this.cw2.Margin = new System.Windows.Forms.Padding(0);
            this.cw2.MaximumSize = new System.Drawing.Size(298, 100);
            this.cw2.MinimumSize = new System.Drawing.Size(298, 100);
            this.cw2.Name = "cw2";
            this.cw2.Size = new System.Drawing.Size(298, 100);
            this.cw2.TabIndex = 24;
            this.cw2.ValueChanged += new Controlz.ColorWheelTR.ValueChangedEventHandler(this.cw2_ValueChanged);
            // 
            // cw1
            // 
            this.cw1.colorval = System.Drawing.Color.Blue;
            this.cw1.Location = new System.Drawing.Point(349, 36);
            this.cw1.Margin = new System.Windows.Forms.Padding(0);
            this.cw1.MaximumSize = new System.Drawing.Size(298, 100);
            this.cw1.MinimumSize = new System.Drawing.Size(298, 100);
            this.cw1.Name = "cw1";
            this.cw1.Size = new System.Drawing.Size(298, 100);
            this.cw1.TabIndex = 23;
            this.cw1.ValueChanged += new Controlz.ColorWheelTR.ValueChangedEventHandler(this.cw1_ValueChanged);
            // 
            // EffectPluginConfigDialog
            // 
            this.AutoScaleDimensions = new System.Drawing.SizeF(96F, 96F);
            this.ClientSize = new System.Drawing.Size(654, 414);
            this.Controls.Add(this.cw2);
            this.Controls.Add(this.cw1);
            this.Controls.Add(this.label2);
            this.Controls.Add(this.reps_lab);
            this.Controls.Add(this.sn_lab);
            this.Controls.Add(this.bias_lab);
            this.Controls.Add(this.choices_lab);
            this.Controls.Add(this.progressBar1);
            this.Controls.Add(this.button2);
            this.Controls.Add(this.button1);
            this.Controls.Add(this.bias);
            this.Controls.Add(this.choices);
            this.Controls.Add(this.reps);
            this.Controls.Add(this.sn);
            this.Controls.Add(this.panel1);
            this.Controls.Add(this.buttonOK);
            this.Controls.Add(this.buttonCancel);
            this.Location = new System.Drawing.Point(0, 0);
            this.Name = "EffectPluginConfigDialog";
            this.FormClosed += new System.Windows.Forms.FormClosedEventHandler(this.EffectPluginConfigDialog_FormClosed);
            this.Load += new System.EventHandler(this.EffectPluginConfigDialog_Load);
            this.VisibleChanged += new System.EventHandler(this.EffectPluginConfigDialog_VisibleChanged);
            this.Paint += new System.Windows.Forms.PaintEventHandler(this.EffectPluginConfigDialog_Paint);
            this.Controls.SetChildIndex(this.buttonCancel, 0);
            this.Controls.SetChildIndex(this.buttonOK, 0);
            this.Controls.SetChildIndex(this.panel1, 0);
            this.Controls.SetChildIndex(this.sn, 0);
            this.Controls.SetChildIndex(this.reps, 0);
            this.Controls.SetChildIndex(this.choices, 0);
            this.Controls.SetChildIndex(this.bias, 0);
            this.Controls.SetChildIndex(this.button1, 0);
            this.Controls.SetChildIndex(this.button2, 0);
            this.Controls.SetChildIndex(this.progressBar1, 0);
            this.Controls.SetChildIndex(this.choices_lab, 0);
            this.Controls.SetChildIndex(this.bias_lab, 0);
            this.Controls.SetChildIndex(this.sn_lab, 0);
            this.Controls.SetChildIndex(this.reps_lab, 0);
            this.Controls.SetChildIndex(this.label2, 0);
            this.Controls.SetChildIndex(this.cw1, 0);
            this.Controls.SetChildIndex(this.cw2, 0);
            this.ResumeLayout(false);
            this.PerformLayout();

        }

        private void buttonOK_Click(object sender, EventArgs e)
        {
            if (RenderComplete)
            {
                saver = true;
                bmp.Save(System.IO.Path.GetTempPath() + @"TRsKN.bmp");
            }
            FinishTokenUpdate();
            DialogResult = DialogResult.OK;
            this.Close();
        }

        private void buttonCancel_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void EffectPluginConfigDialog_Load(object sender, EventArgs e)
        {
            panelbounds = panel1.ClientRectangle;
            mybounds = EffectSourceSurface.Bounds;
            Version version = Assembly.GetExecutingAssembly().GetName().Version;
            this.Text = EffectPlugin.StaticName + " ver. " + version.Major + "." + version.Minor + "." + version.Build;
            bmp = new Bitmap(mybounds.Width, mybounds.Height, System.Drawing.Imaging.PixelFormat.Format32bppArgb);
        }

  
        private void panel1_Paint(object sender, PaintEventArgs e)
        {
            if (button1.Enabled)
            {
                drawpanel();
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            GlobalCancel = true;
        }

        private void generic_ValueChanged(object sender, EventArgs e)
        {
            RenderComplete = false;
            HScrollBar ctl = (HScrollBar)sender;
            Label lab = (Label)this.Controls[ctl.Name + "_lab"];
            lab.Text = lab.Tag + " " + ctl.Value.ToString();
        }

        private void EffectPluginConfigDialog_FormClosed(object sender, FormClosedEventArgs e)
        {
            bmp.Dispose();
        }

        private void EffectPluginConfigDialog_Paint(object sender, PaintEventArgs e)
        {
        }

        private void drawpanel()
        {
            Graphics g = panel1.CreateGraphics();
            panel1.CreateGraphics();
            HatchBrush hb = new HatchBrush(HatchStyle.LargeCheckerBoard, Color.LightGray, Color.White);
            g.FillRectangle(hb, panel1.ClientRectangle);
            hb.Dispose();
            g.DrawImage(bmp,0,0);
            g.Dispose();
        }

        private unsafe void button1_Click(object sender, EventArgs e)
        {
            int i, j, x, y, c;
            double percent = (double)sn.Value * .0025 / 5;
            double mass = mybounds.Height * mybounds.Width * percent;
            EnableControls(false);
            GlobalCancel = false;
            RenderComplete = false;
            int block1 = biasgrid[bias.Value] / 8;
            int block2 = biasgrid[bias.Value] % 8;


            //seed pass
            Graphics g = Graphics.FromImage(bmp);
            g.Clear(Color.Black);
            g.Dispose();

            for (i = 0; i < mass; i++)
            {
                x = rnd.Next(mybounds.Width);
                y = rnd.Next(mybounds.Height);
                bmp.SetPixel(x, y, Color.White);
            }

            Int64 maxreps = mybounds.Width * mybounds.Height * reps.Value;
            Int64 count = 0;
            for (j = 0; j < reps.Value; j++)
            {
                System.Drawing.Imaging.BitmapData bmd = bmp.LockBits(mybounds, System.Drawing.Imaging.ImageLockMode.ReadOnly, bmp.PixelFormat);
                byte* row = (byte*)bmd.Scan0;

                Bitmap bmp2 = new Bitmap(mybounds.Width, mybounds.Height, System.Drawing.Imaging.PixelFormat.Format32bppArgb);

                System.Drawing.Imaging.BitmapData bmd2 = bmp2.LockBits(mybounds, System.Drawing.Imaging.ImageLockMode.ReadOnly, bmp2.PixelFormat);
                byte* row2 = (byte*)bmd2.Scan0;

                byte val = (byte)(255 - j * 255 / reps.Value);
                for (y = 0; y < mybounds.Height; y++)
                {
                    for (x = 0; x < mybounds.Width; x++)
                    {
                        c = (int)row[y * bmd.Stride + x * 4 + 0];
                        bool nogo = false;
                        if (c == 0)
                        {
                            for (i = 0; i < 8; i++)
                            {

                                int gridx = x + grid[i, 0];
                                gridx = (gridx < 0) ? 0 : (gridx >= mybounds.Width) ? mybounds.Width - 1 : gridx;
                                int gridy = y + grid[i, 1];
                                gridy = (gridy < 0) ? 0 : (gridy >= mybounds.Height) ? mybounds.Height - 1 : gridy;

                                c = (int)row[gridy * bmd.Stride + gridx * 4 + 0];

                                if (c > (int)val)
                                {
                                    if (rnd.Next(choices.Value) == 1 && (i != block1) && (i != block2))
                                    {
                                        row2[y * bmd2.Stride + x * 4 + 0] = val;
                                    }
                                    nogo = true;
                                }
                                if (nogo) break;
                            }
                        }
                        else
                        {
                            row2[y * bmd2.Stride + x * 4 + 0] = row[y * bmd.Stride + x * 4 + 0];

                        }
                        count++;
                        if (GlobalCancel) break;

                    }
                    if (count > maxreps) count = maxreps;
                    progressBar1.Value = (int)(count * 75 / maxreps);
                    Application.DoEvents();
                    if (GlobalCancel) break;
                }
                bmp.UnlockBits(bmd);
                bmp = (Bitmap)bmp2.Clone();
                bmp2.UnlockBits(bmd2);
                bmp2.Dispose();
            }


            System.Drawing.Imaging.BitmapData bmd3 = bmp.LockBits(mybounds, System.Drawing.Imaging.ImageLockMode.ReadOnly, bmp.PixelFormat);
            byte* row3 = (byte*)bmd3.Scan0;

            for (y = 0; y < mybounds.Height; y++)
            {
                for (x = 0; x < mybounds.Width; x++)
                {

                    double r, gr, b, a;
                    double idx = (double)row3[y * bmd3.Stride + x * 4 + 0] / 255;
                    b = (double)colorval[0].B * idx + (double)colorval[1].B - (double)colorval[1].B * idx;
                    gr = (double)colorval[0].G * idx + (double)colorval[1].G - (double)colorval[1].G * idx;
                    r = (double)colorval[0].R * idx + (double)colorval[1].R - (double)colorval[1].R * idx;
                    a = (double)colorval[0].A * idx + (double)colorval[1].A - (double)colorval[1].A * idx;
                    row3[y * bmd3.Stride + x * 4 + 0] = (byte)(b);
                    row3[y * bmd3.Stride + x * 4 + 1] = (byte)(gr);
                    row3[y * bmd3.Stride + x * 4 + 2] = (byte)(r);
                    row3[y * bmd3.Stride + x * 4 + 3] = (byte)(a);
                }
            }

            bmp.UnlockBits(bmd3);
            progressBar1.Value = 100;
            EnableControls(true);
            panel1.Refresh();
            RenderComplete = !GlobalCancel;
        }

        private void EnableControls(bool b)
        {
            button1.Enabled = b;
            sn.Enabled = b;
            reps.Enabled = b;
            choices.Enabled = b;
            bias.Enabled = b;
            buttonOK.Enabled = b;
        }

        private void panel2_Paint(object sender, PaintEventArgs e)
        {

        }

        private void EffectPluginConfigDialog_VisibleChanged(object sender, EventArgs e)
        {

        }

        private void cw2_ValueChanged(object sender, Color e)
        {
            colorval[1] = e;
        }

        private void cw1_ValueChanged(object sender, Color e)
        {
            colorval[0] = e;
        }


    }
}